# NOTE: this class has been translated from Java.
# Do not modify this file, changes will be overwritten.

#package orbitgt.mapping3d.sdk.viewer;

from .....com.orbitgis.tool.Strings import Strings

#
# Class Color defines a color value with red, green and blue component and an optional alpha. All values are in the 0..255 integer range.
#

class Color:
    # The type of objects in this class */
    TYPE: str = "O"

    # The red component of the color (0..255) */
    #public int red
    # The green component of the color (0..255) */
    #public int green
    # The blue component of the color (0..255) */
    #public int blue
    # The alpha (transparency) component of the color (0..255, where 255 is opaque) */
    #public int alpha

    #
    # Create a new color.
    # @param red the red component of the color (0..255).
    # @param green the green component of the color (0..255).
    # @param blue the blue component of the color (0..255).
    # @param alpha the alpha (transparency) component of the color (0..255, where 255 is opaque).
    #
    def __init__(self,red: int,green: int,blue: int,alpha: int):
        self.red = red
        self.green = green
        self.blue = blue
        self.alpha = alpha

    #
    # Create a new RGB color.
    # @param red the red component of the color (0..255).
    # @param green the green component of the color (0..255).
    # @param blue the blue component of the color (0..255).
    # @return the color.
    #
    def fromRGB(red: int,green: int,blue: int) -> 'Color':
        return Color(red,green,blue,255)

    #
    # Create a new RGBA color.
    # @param red the red component of the color (0..255).
    # @param green the green component of the color (0..255).
    # @param blue the blue component of the color (0..255).
    # @param alpha the alpha (transparency) component of the color (0..255, where 255 is opaque).
    # @return the color.
    #
    def fromRGBA(red: int,green: int,blue: int,alpha: int) -> 'Color':
        return Color(red,green,blue,alpha)

    #
    # Convert the color to an R.G.B string.
    # @return the string.
    #
    def toStringRGB(self) -> str:
        return ""+Strings.toStringInt(self.red)+"."+Strings.toStringInt(self.green)+"."+Strings.toStringInt(self.blue)

    #
    # Convert the color to an R.G.B.A string.
    # @return the string.
    #
    def toStringRGBA(self) -> str:
        return ""+Strings.toStringInt(self.red)+"."+Strings.toStringInt(self.green)+"."+Strings.toStringInt(self.blue)+"."+Strings.toStringInt(self.alpha)

    #
    # Convert the color to an A.R.G.B string.
    # @return the string.
    #
    def toStringARGB(self) -> str:
        return ""+Strings.toStringInt(self.alpha)+"."+Strings.toStringInt(self.red)+"."+Strings.toStringInt(self.green)+"."+Strings.toStringInt(self.blue)

    #
    # Convert the object to a string.
    # @return the string form of the object.
    #
    def toString(self) -> str:
        return "[Color:r="+Strings.toStringInt(self.red)+",g="+Strings.toStringInt(self.green)+",b="+Strings.toStringInt(self.blue)+",a="+Strings.toStringInt(self.alpha)+"]"
